#check total ready players
scoreboard players set @e[name=Global] total_players 0
execute as @a[team=!spectator] run scoreboard players add @e[name=Global] total_players 1

#cancel ready up if player leaves
execute if entity @e[name=Global,scores={pregame_timer=..220,total_players=..1},tag=classic] run tag @e[name=Global] add cancel_start
execute if entity @e[name=Global,scores={pregame_timer=..220,total_players=..0},tag=target] run tag @e[name=Global] add cancel_start
execute if entity @e[name=Global,scores={pregame_timer=..220,total_players=..1},tag=snipers] run tag @e[name=Global] add cancel_start

#----------------- Non-Admin ---------------------
#replace dropped item (lime concrete)
execute unless entity @a[tag=admin] unless entity @e[name=Global,scores={pregame_timer=1..}] as @a[team=!spectator] if entity @s[tag=!p] unless entity @s[nbt={Inventory:[{Slot:4b,id:"minecraft:lime_concrete"}]}] run tag @s add drop_ready
execute as @a[tag=drop_ready] run clear @s lime_concrete
#execute as @a[tag=drop_ready] at @s run playsound minecraft:block.fire.extinguish master @s ~ ~ ~ 1 2
execute as @a[tag=drop_ready] run replaceitem entity @s hotbar.4 lime_concrete{display:{Name:'[{"text":"Right-Click","color":"dark_green","bold":true},{"text":" to start!","color":"dark_green","bold":false}]'}}
execute as @a[tag=drop_ready] run tag @s remove drop_ready

#give concrete if start is initiated
execute unless entity @a[tag=admin] if entity @e[name=Global,scores={pregame_timer=219}] as @a[team=!spectator,tag=!p] run replaceitem entity @s hotbar.4 red_concrete{display:{Name:'[{"text":"Right-Click","color":"red","bold":true},{"text":" to cancel!","color":"red","bold":false}]'}}

#replace dropped item (red concrete)
execute unless entity @a[tag=admin] if entity @e[name=Global,scores={pregame_timer=1..}] as @a[team=!spectator] if entity @s[tag=!p] unless entity @s[nbt={Inventory:[{Slot:4b,id:"minecraft:red_concrete"}]}] run tag @s add drop_cancel
execute as @a[tag=drop_cancel] run clear @s red_concrete
#execute as @a[tag=drop_cancel] at @s run playsound minecraft:block.fire.extinguish master @s ~ ~ ~ 1 2
execute as @a[tag=drop_cancel] run replaceitem entity @s hotbar.4 red_concrete{display:{Name:'[{"text":"Right-Click","color":"red","bold":true},{"text":" to cancel!","color":"red","bold":false}]'}}
execute as @a[tag=drop_cancel] run tag @s remove drop_cancel

#ready-up process
execute if entity @a[scores={click=1..},nbt={SelectedItem:{id:"minecraft:lime_concrete"}}] if entity @e[name=Global,tag=classic,scores={total_players=2..}] run scoreboard players set @e[name=Global] pregame_timer 220
execute as @a if entity @s[scores={click=1..},nbt={SelectedItem:{id:"minecraft:lime_concrete"}}] if entity @e[name=Global,tag=classic,scores={total_players=..1}] run title @s actionbar ["",{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" Not enough players to begin","color":"red"}]
execute as @a at @s if entity @s[scores={click=1..},nbt={SelectedItem:{id:"minecraft:lime_concrete"}}] if entity @e[name=Global,tag=classic,scores={total_players=..1}] run playsound minecraft:entity.villager.no master @s ~ ~ ~ 1 1
execute if entity @a[scores={click=1..},nbt={SelectedItem:{id:"minecraft:lime_concrete"}}] if entity @e[name=Global,tag=target,scores={total_players=1..}] run scoreboard players set @e[name=Global] pregame_timer 220
execute as @a if entity @s[scores={click=1..},nbt={SelectedItem:{id:"minecraft:lime_concrete"}}] if entity @e[name=Global,tag=target,scores={total_players=0}] run title @s actionbar ["",{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" Not enough players to begin","color":"red"}]
execute as @a at @s if entity @s[scores={click=1..},nbt={SelectedItem:{id:"minecraft:lime_concrete"}}] if entity @e[name=Global,tag=target,scores={total_players=0}] run playsound minecraft:entity.villager.no master @s ~ ~ ~ 1 1
execute if entity @a[scores={click=1..},nbt={SelectedItem:{id:"minecraft:lime_concrete"}}] if entity @e[name=Global,tag=snipers,scores={total_players=2..}] run scoreboard players set @e[name=Global] pregame_timer 220
execute as @a if entity @s[scores={click=1..},nbt={SelectedItem:{id:"minecraft:lime_concrete"}}] if entity @e[name=Global,tag=snipers,scores={total_players=..1}] run title @s actionbar ["",{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" Not enough players to begin","color":"red"}]
execute as @a at @s if entity @s[scores={click=1..},nbt={SelectedItem:{id:"minecraft:lime_concrete"}}] if entity @e[name=Global,tag=snipers,scores={total_players=..1}] run playsound minecraft:entity.villager.no master @s ~ ~ ~ 1 1
execute if entity @e[name=Global,scores={pregame_timer=1..}] run clear @a lime_concrete
execute if entity @e[name=Global,scores={pregame_timer=1..}] run bossbar set minecraft:readytimer players @a[team=!spectator]
execute if entity @e[name=Global,scores={pregame_timer=1..}] run bossbar set minecraft:readytimer visible true
execute if entity @e[name=Global,scores={pregame_timer=219}] as @a[team=!spectator] at @s run playsound minecraft:entity.arrow.hit_player master @s ~ ~ ~ 1 1

#timer
execute if entity @e[name=Global,scores={pregame_timer=1..}] run scoreboard players remove @e[name=Global] pregame_timer 1
execute if entity @e[name=Global,scores={pregame_timer=1..}] run scoreboard players operation @e[name=Global] pregame_timer_s = @e[name=Global] pregame_timer
execute if entity @e[name=Global,scores={pregame_timer=1..}] run scoreboard players operation @e[name=Global] pregame_timer_s /= @e[name=Global] global_20
execute if entity @e[name=Global,scores={pregame_timer=1..}] store result bossbar minecraft:readytimer value run scoreboard players get @e[name=Global,limit=1] pregame_timer_s

#cancel process
execute if entity @e[name=Global,scores={pregame_timer=1..}] if entity @a[scores={click=1..},nbt={SelectedItem:{id:"minecraft:red_concrete"}}] run tag @e[name=Global] add cancel_start
execute if entity @e[name=Global,tag=cancel_start] run scoreboard players reset @e[name=Global] pregame_timer
execute if entity @e[name=Global,tag=cancel_start] run scoreboard players reset @e[name=Global] pregame_timer_s
execute if entity @e[name=Global,tag=cancel_start] as @a[team=!spectator] at @s run playsound minecraft:entity.villager.no master @s ~ ~ ~ 1 1
execute if entity @e[name=Global,tag=cancel_start] run bossbar set minecraft:readytimer visible false
execute if entity @e[name=Global,tag=cancel_start] run title @a[team=!spectator] actionbar ["",{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" Start cancelled","color":"red"}]
execute if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a[team=!spectator,tag=!p] hotbar.4 lime_concrete{display:{Name:'[{"text":"Right-Click","color":"dark_green","bold":true},{"text":" to start!","color":"dark_green","bold":false}]'}}

#give back inventory items
execute unless entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a inventory.10 white_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ls"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:0,Pattern:"bo"}]},HideFlags:63,display:{Name:'{"text":"Classic","color":"white","bold":false}'}}
execute unless entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a inventory.11 white_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ts"},{Color:15,Pattern:"cs"},{Color:0,Pattern:"bo"}]},HideFlags:63,display:{Name:'{"text":"Target Shootout","color":"white","bold":false}'}}
execute unless entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a inventory.12 white_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"drs"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:0,Pattern:"bo"}]},HideFlags:63,display:{Name:'{"text":"Sky Snipers","color":"white","bold":false}'}}
execute unless entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start,tag=classic] run replaceitem entity @a inventory.10 lime_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ls"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:5,Pattern:"bo"}]},HideFlags:63,display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Classic","color":"white","bold":false}]'}}
execute unless entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start,tag=target] run replaceitem entity @a inventory.11 lime_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ts"},{Color:15,Pattern:"cs"},{Color:5,Pattern:"bo"}]},HideFlags:63,display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Target Shootout","color":"white","bold":false}]'}}
execute unless entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start,tag=snipers] run replaceitem entity @a inventory.12 lime_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"drs"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:5,Pattern:"bo"}]},HideFlags:63,display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Sky Snipers","color":"white","bold":false}]'}}

execute if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a inventory.14 minecraft:light_blue_stained_glass{display:{Name:'{"text":"Join Scapers","color":"aqua","bold":false}'}}
execute if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a inventory.15 red_stained_glass{display:{Name:'{"text":"Join Seekers","color":"dark_red","bold":false}'}}
execute if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a inventory.16 gray_stained_glass{display:{Name:'{"text":"Join Spectators","color":"dark_gray","bold":false}'}}
execute if entity @e[name=Global,tag=cancel_start] as @a[team=scapers] run replaceitem entity @s inventory.14 minecraft:light_blue_wool{display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Join Scapers","color":"aqua","bold":false}]'}}
execute if entity @e[name=Global,tag=cancel_start] as @a[team=seeker] run replaceitem entity @s inventory.15 red_wool{display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Join Seekers","color":"dark_red","bold":false}]'}}
execute if entity @e[name=Global,tag=cancel_start] as @a[team=spectator] run replaceitem entity @s inventory.16 gray_wool{display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Join Spectators","color":"gray","bold":false}]'}}


#-------------------------------------- Admin ----------------------------------------------------
#replace dropped item (lime concrete)
execute if entity @a[tag=admin] unless entity @e[name=Global,scores={pregame_timer=1..}] as @a[tag=admin] if entity @s[tag=!p] unless entity @s[nbt={Inventory:[{Slot:4b,id:"minecraft:lime_concrete"}]}] run tag @s add drop_ready

#give concrete if start is initiated
execute if entity @a[tag=admin] if entity @e[name=Global,scores={pregame_timer=219}] as @a[tag=admin,tag=!p] run replaceitem entity @s hotbar.4 red_concrete{display:{Name:'[{"text":"Right-Click","color":"red","bold":true},{"text":" to cancel!","color":"red","bold":false}]'}}

#replace dropped item (red concrete)
execute if entity @a[tag=admin] if entity @e[name=Global,scores={pregame_timer=1..}] as @a[tag=admin] if entity @s[tag=!p] unless entity @s[nbt={Inventory:[{Slot:4b,id:"minecraft:red_concrete"}]}] run tag @s add drop_cancel

#give back inventory items
execute if entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a[tag=admin] inventory.10 white_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ls"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:0,Pattern:"bo"}]},HideFlags:63,display:{Name:'{"text":"Classic","color":"white","bold":false}'}}
execute if entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a[tag=admin] inventory.11 white_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ts"},{Color:15,Pattern:"cs"},{Color:0,Pattern:"bo"}]},HideFlags:63,display:{Name:'{"text":"Target Shootout","color":"white","bold":false}'}}
execute if entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start] run replaceitem entity @a[tag=admin] inventory.12 white_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"drs"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:0,Pattern:"bo"}]},HideFlags:63,display:{Name:'{"text":"Sky Snipers","color":"white","bold":false}'}}
execute if entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start,tag=classic] run replaceitem entity @a[tag=admin] inventory.10 lime_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ls"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:5,Pattern:"bo"}]},HideFlags:63,display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Classic","color":"white","bold":false}]'}}
execute if entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start,tag=target] run replaceitem entity @a[tag=admin] inventory.11 lime_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ts"},{Color:15,Pattern:"cs"},{Color:5,Pattern:"bo"}]},HideFlags:63,display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Target Shootout","color":"white","bold":false}]'}}
execute if entity @a[tag=admin] if entity @e[name=Global,tag=cancel_start,tag=snipers] run replaceitem entity @a[tag=admin] inventory.12 lime_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"drs"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:5,Pattern:"bo"}]},HideFlags:63,display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Sky Snipers","color":"white","bold":false}]'}}

execute if entity @e[name=Global,tag=cancel_start] run tag @e[name=Global] remove cancel_start



#-------------------------------- start game ------------------------------------------------
execute if entity @e[name=Global,scores={pregame_timer=0}] run tag @e[name=Global] add start_game
execute if entity @e[name=Global,tag=start_game] run scoreboard players reset @e[name=Global] pregame_timer
execute if entity @e[name=Global,tag=start_game] run scoreboard players reset @e[name=Global] pregame_timer_s
execute if entity @e[name=Global,tag=start_game] run scoreboard players set @e[name=Global] gameState 1